/* 
 * File:   CImgtAmbiguities.h
 * Author: mwittig
 *
 * Created on March 13, 2013, 1:35 PM
 */

#ifndef _CIMGTAMBIGUITIES_H
#define	_CIMGTAMBIGUITIES_H

using namespace std;

class CImgtAmbiguities {

public:
    class CGAllele {
      public:
        CGAllele() : ref_name(""){};
        CGAllele(const string& name, const vector<string>& alleles){
            this->alleles = alleles;
            ref_name      = name;
        };
        CGAllele(const CGAllele& orig){
            alleles = orig.alleles;
            ref_name= orig.ref_name;
        };
        virtual ~CGAllele(){};

        vector<string>  alleles;
        string          ref_name;
    };


    bool isAmbiguityOfBetterGAllele(const string& allele,vector<string> alternatives);


public:
    CImgtAmbiguities();
    CImgtAmbiguities(const string& filename_ambiguities,const string& filename_chimera);
    CImgtAmbiguities(const CImgtAmbiguities& orig);
    virtual ~CImgtAmbiguities();


private:

    vector<CGAllele>                    m_vctAmbiguities;
    
    // Allele,pair<m_vctAmbiguities[idx], m_vctAmbiguities[idx].alleles[idx]>
    map<string,pair<size_t,size_t> >    m_amb_pointer;

    void readAmbiguityTable(const char* filename);

    vector<string> Tokenize(const string&, const string& delimiters);
    vector<string> Tokenize(const string&);

};

#endif	/* _CIMGTAMBIGUITIES_H */

