/* 
 * File:   CImgtDb.h
 * Author: mwittig
 *
 * Created on December 6, 2011, 9:01 AM
 */

#ifndef _CIMGTDB_H
#define	_CIMGTDB_H


using namespace std;

class CImgtDb {
public:

        typedef struct{
        string strTemplateAllele;
        string strTemplateSequence;
        map<string,string>  mapMultipleAlignment;
    }multiSeqAlignment;


    CImgtDb();
    CImgtDb(const char* filename);
    CImgtDb(const char* filename,const char* filename_bias);
    CImgtDb(const CImgtDb& orig);
    virtual ~CImgtDb();

    pair<string,string> operator[](const string&);
    pair<string,string> getUnmanipulatedSequence(const string&);
    //  allel,     sequenz,  ambiguous_pos
    map<string,string>  getAll(){return the_alignments.mapMultipleAlignment;}

    typedef map<string,string>::iterator iterator;
    typedef map<string,string>::const_iterator const_iterator;

    map<string,string>::iterator begin(){return the_alignments.mapMultipleAlignment.begin(); }
    map<string,string>::iterator end(){return the_alignments.mapMultipleAlignment.end();}
    map<string,string>::iterator find(const string& v){return the_alignments.mapMultipleAlignment.find(v);}
    void erase(iterator i){return the_alignments.mapMultipleAlignment.erase(i);}

    map<string, set<string> > getUniqueSequences(bool remove_special_characters = true);


    vector<pair<unsigned int, unsigned int> > getPhasableExons(const string& a1,const string& a2, unsigned int min_length);

    multiSeqAlignment the_alignments;

private:
    
    // position, nucleotide, HLA allele
    
    multiSeqAlignment getAlignmentAsMap(const char* filename, const char* strand = "plus");

    string erase_characters (string rep, string in);
    bool findFaStart(ifstream& the_file);
    //bool findFaStart(ifstream& the_file);
    pair<string,string> readMultiAlignLine(ifstream& the_file);
    string getFaSequence(string strTmp,unsigned int lineBreaks);
    char   getOneLetterNucleotide(set<char>& the_nucs);
    bool isRegularNucleotide(const char);

    char GetComplNuc(const char& source);
    string GetComplSequence(string& strSequence);

    void removeSequencesFromBiasFile(const char* filename);

    vector<string> Tokenize(const string& str, const string& delimiters = "\t");

};

#endif	/* _CIMGTDB_H */

