/* 
 * File:   main.cpp
 * Author: mwittig
 *
 * Created on January 11, 2012, 2:08 PM
 */
#include <stdlib.h>

#include <string>
#include <iostream>
#include <sstream>
#include <ostream>
#include <iomanip>
#include <stdint.h>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <string.h>
#include <algorithm>
#include <iterator>
#include <numeric>
#include <exception>


#include "CImgtDb.h"

#define BOOST_ALL_NO_LIB

using namespace std;

bool IsNumeric(const char *p);
bool IsNumeric(const char p);
string getClosestId(set<string> idSet, string id);
vector<string> Tokenize(const string& str, const string& delimiters);

typedef struct gen_struct{
    
    map<int,string>      intron;
    
}stcGen;


/*
 * 
 */

int main(int argc, char** argv) {
    
    try
    {
        CImgtDb idbn(argv[1]);
        //CImgtDb idbn("/home/mwittig/data/HLA/annotation/enrichment/Agilent/improve/manual_manipulated_alignments/B_nuc.txt");
        map<string,string> the_nuc_map = idbn.getAll();

        for(map<string,string>::iterator iter = the_nuc_map.begin(); iter != the_nuc_map.end(); iter++)
        {
            //cout << '>' << iter->first << " cDNA with intron sequences from " << closest_id << endl;
            //cerr << '>' << iter->first << "\t" << closest_id << endl;
            // iter = the_nuc_map.find("A*01:01:01:01");
            int exon_count = 1;
            string seq = iter->second;
            for(string::iterator iterS = seq.begin(); iterS != seq.end(); iterS++)
            {
                if(string("ACGTacgt|").find(*iterS) == string::npos)
                    seq.erase(iterS--);
            }
            vector<string> m_exon_sequences = Tokenize(seq,"|");
            int j=0;
            for(int i = 0; i < m_exon_sequences.size(); i++)
            {
                if(m_exon_sequences[i] == "")
                    continue;
                cout << '>' << iter->first << " block " << i << endl << m_exon_sequences[i] << endl;
            }
       }
        exit(EXIT_SUCCESS);
    }
    catch(const string& err)
    {
        cerr << err << endl;
        exit(EXIT_FAILURE);
    }
    catch(...)
    {
        cerr << "Unknown error occured" << endl;
        exit(EXIT_FAILURE);
    }
    
    return 0;
}

bool IsNumeric(const char p)
{
    string value("");
    value+=p;
    
    return IsNumeric(value.c_str());
}

bool IsNumeric(const char *p)
{
    for ( ; *p; p++)
        if (*p < '0' || *p > '9')
                return false;
    return true;
}

vector<string> Tokenize(const string& str, const string& delimiters = "\t")
{
    vector<string> tokens;
    // Skip delimiters at beginning.
    string::size_type lastPos = str.find_first_not_of(delimiters, 0);
    // Find first "non-delimiter".
    string::size_type pos     = str.find_first_of(delimiters, lastPos);

    while (string::npos != pos || string::npos != lastPos)
    {
        // Found a token, add it to the vector.
        tokens.push_back(str.substr(lastPos, pos - lastPos));
        // Skip delimiters.  Note the "not_of"
        if(str.length() > pos && delimiters.find(str[pos]) != string::npos )
            lastPos=pos+1;
        else
            lastPos = str.find_first_not_of(delimiters, pos);
        // Find next "non-delimiter"
        pos = str.find_first_of(delimiters, lastPos);
    }
    return tokens;
}
