#ifndef MYTOOLS_H_
#define MYTOOLS_H_

using namespace std;

#define MYTOOLS_H_MAX_ITOA_DIGITS_SIZE 35

class CMyTools
{
public:
	CMyTools();
	virtual ~CMyTools();

	// String manipulation	
	static vector<string> GetParsedLine(string,const char* sep);
	static vector<string> GetParsedLine(string);
	static string	      ReplaceSubstr(std::string result, const std::string& replaceWhat,  const std::string& replaceWithWhat);
        static string         dtoa(long value, int base);
        
	// File System
	static vector<string> GetDirectoryListing(const char* path);
        static vector<string> GetDirectoryListing(const char* path,const char* contains);
	
	static bool isNumeric(const char *);
	
	// genetic code
	static string GetComplSequence(string& strSequence);
	static char   GetComplNuc(const char& source);
	static vector<unsigned int> FindApproxSubs(unsigned int k, string & P, string & T);

        template<class T> static void GetMem(T*& OldMem, int Elems);
        
	// AB color code
	static string getBasespace(string cs,bool keep_lead_base=true);
	static string getBasespaceRev(string cs,bool keep_lead_base=true);
	static char   decodeBaseChange(char base, char cc);
        
private:

};

#endif /*MYTOOLS_H_*/


